#Use at your own risk, beginners edit of code by others Eric_Erb_and_AJB

#Intended to find component's names, and texture them by matching
#the component name to the texture name. If the component is a imported
#DXF, its name includes the extention ".DXF", which will be ignored.

#10/30/09 ignore file extention name

require 'sketchup'

module Eric_Erb_and_AJB 

    def self.texture_by_component 
        mod = Sketchup.active_model
        su_materials = mod.materials

        begin
            mod.start_operation("Texture By Component", true)
        rescue ArgumentError
            mod.start_operation("Texture By Component")
        end

        # Loop through entities & apply material based on layer name
        Sketchup.active_model.entities.each do |e| # Do Loop
		            begin # if here found
				# 10/30/09 ignore file extention name start
				stuff=e.definition.name
				stuff=stuff.split('.').first
				mat = su_materials[stuff]
                # mat = su_materials[e.definition.name]#original
				# end
             rescue # Else must be not found
                mat = su_materials[e.name]
            end # Endif
            unless mat.nil?#if not mat.nil then found and set it
                if e.is_a? Sketchup::ComponentInstance or e.is_a? Sketchup::Group then
                    e.material = mat
                end # Endif
            end # Endif
			
        end # End Loop
        mod.commit_operation
    end
	
end

unless file_loaded? File::basename(__FILE__)
    UI.menu('Plugins').add_item('Texture By Component') { Eric_Erb_and_AJB.texture_by_component }
    file_loaded File::basename(__FILE__)
end
